<?php if (!defined('PmWiki')) exit();

/* metadata.php -- provides metadata for PmWiki pages
 * Copyright 2004, Evan Prodromou <evan@pigdog.org>.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$MetadataVersion = '0.2';

/* BEGIN ADMIN-VARIABLES. */

/* Which MIME type to use for RDF.*/

SDV($RdfMimeType, 'text/xml');

/* An 'About' page. */

SDV($AboutPage, "$DefaultGroup.$WikiTitle");

/* A page that gives the copyright policy for the site. */

SDV($CopyrightPage, "$DefaultGroup.CopyrightPolicy");

/* An URL for the license of your site. */

SDV($LicenseUrl, NULL);

/* Some plain text to explain your copyright policy. */

SDV($CopyrightText, NULL);

/* END ADMIN-VARIABLES. */

/* Add external metadata */

function AddMetadata($code, $funcname) {
    
    global $HandleActions, $action, $pagename, $HTMLHeaderFmt, $RdfMimeType;
    static $HaveMetaLink = false;
    
    $HandleActions[$code] = $funcname;

    /* We show a <link> element for browsing. */

    $rel = ($HaveMetaLink) ? 'alternate meta' : 'meta';
    
    $HaveMetaLink = true;
	
    if ($action == 'browse') {
	if ($pagename == '') $pagename = $DefaultPage;
	$pageurl = FmtPageName('$PageUrl', $pagename);
	$RdfUrl = $pageurl . "?action={$code}";
	$HTMLHeaderFmt[] = "<link rel='{$rel}' type='{$RdfMimeType}' href='{$RdfUrl}' />\n";
    }
}

/* Output one element. */

function NsElement($ns, $name, $value) {
    echo "    <{$ns}:{$name}>{$value}</{$ns}:{$name}>\n";
}

function NsPage($ns, $name, $page) {
    NsUrl($ns, $name, FmtPageName('$PageUrl', $page));
}

function NsUrl($ns, $name, $url) {
    echo "    <{$ns}:{$name} rdf:resource=\"{$url}\" />\n";
}

function NsPageOrString($ns, $name, $page, $string) {
    if (isset($page) && PageExists($page)) {
       NsPage($ns, $name, $page);
    } else {
	NsElement($ns, $name, $string);
    }
}

/* For a person, we either want a link to their user page,
 * if it exists, or their user name spaced out, or just "Anonymous"
 * if no person was provided. */

function NsPerson($ns, $name, $person) {
    if (!$person) {
	NsElement($ns, $name, 'Anonymous');
    } else {
	global $AuthorGroup;
	$profile = "$AuthorGroup.$person";
	NsPageOrString($ns, $name, $profile, AsSpaced($person));
    }
}

include_once('local/creativecommons.php');
include_once('local/dublincore.php');

?>
